#-----------------------------------------------------------------------------
%{?!dist:	%define	dist	.ok}
%define		__python	/usr/bin/python3
%define		appname		named
%define		jail		/jail/%{name}
#-----------------------------------------------------------------------------
Name		:	bind
Version		:	9.18.17
Release		:	17.2.79.rel%{?dist}

Summary		:	The Berkeley Internet Name Domain (BIND) DNS (Domain Name System) server
Group		:	System Environment/Daemons

Packager	:	Osukiss Project	<build-ok@osukiss.org>

License		:	ISC
URL		:	https://www.isc.org
			# ftp://ftp.isc.org/isc/bind9

Source0		:	%{name}-%{version}.tar.xz
Source1		:	%{name}-ok_addon.tar.gz

#-----------------------------------------------------------------------------
BuildRequires	:	python-ply

Requires(pre)	:	logrotate
Requires	:	coreutils
Requires	:	psmisc
Requires	:	/usr/sbin/useradd, /usr/sbin/userdel
Requires	:	/usr/sbin/groupadd, /usr/sbin/groupdel
Requires	:	lfs-bootscripts
Requires	:	chkconfig

Requires	:	%{name}-libs = %{version}-%{release}

#-----------------------------------------------------------------------------
%description
The BIND name server, named, is able to serve as an authoritative name
server, recursive resolver, DNS forwarder, or all three simultaneously. It
implements views for split-horizon DNS, automatic DNSSEC zone signing and
key management, catalog zones to facilitate provisioning of zone data
throughout a name server constellation, response policy zones (RPZ) to
protect clients from malicious data, response rate limiting (RRL) and
recursive query limits to reduce distributed denial of service attacks,
and many other advanced DNS features. BIND also includes a suite of
administrative tools, including the dig and delv DNS lookup tools,
nsupdate for dynamic DNS zone updates, rndc for remote name server
administration, and more.

#-----------------------------------------------------------------------------
%files			
%defattr(-,root,root,-)
%doc README.md
%attr(0750,root,root) %{_sysconfdir}/rc.d/init.d/%{appname}
%config (noreplace) %{_sysconfdir}/logrotate.d/%{appname}
%{_bindir}/arpaname
%{_bindir}/dig
%{_bindir}/delv
%{_bindir}/mdig
%{_bindir}/nslookup
%{_bindir}/nsupdate
%{_bindir}/host
%{_bindir}/dnssec-*
%{_bindir}/%{appname}-*
%{_bindir}/nsec3hash
%{_sbindir}/ddns-confgen
%{_sbindir}/%{appname}
%{_sbindir}/rndc*
%{_sbindir}/tsig-keygen
%{_mandir}/man1/*.1.gz
%{_mandir}/man5/*.5.gz
%{_mandir}/man8/*.8.gz
#excluding bind-utils contents
%exclude %{_bindir}/dig
%exclude %{_bindir}/host
%exclude %{_bindir}/nslookup
%exclude %{_bindir}/nsupdate
%exclude %{_mandir}/man1/host.1*
%exclude %{_mandir}/man1/nsupdate.1*
%exclude %{_mandir}/man1/dig.1*
%exclude %{_mandir}/man1/nslookup.1*

#-----------------------------------------------------------------------------
%pre
#after upgrade or remove
if [ "$1" = 1 ]; then
  /usr/sbin/groupadd				\
	-K GID_MIN=50				\
	-K GID_MAX=99				\
	 %{appname}
  /usr/sbin/useradd 				\
	-r					\
	-c "Named Server"			\
	-K SYS_UID_MIN=50			\
	-K SYS_UID_MAX=99			\
	-g %{appname}				\
	-s /sbin/nologin			\
	-d %{_sysconfdir}			\
	%{appname}
  fi

%preun
if [ "$1" = 0 ]; then
  %{_sysconfdir}/rc.d/init.d/%{appname} stop > /dev/null 2>&1 || :
  %{_sbindir}/chkconfig --del %{appname}
  /usr/sbin/userdel %{appname}
  (
  /bin/echo -n "%{name}-%{version} has been fully removed on "; date
  ) > %{_var}/log/README-%{name}-removed
  fi

%post
%{_sbindir}/chkconfig --add %{appname}
%{_sysconfdir}/rc.d/init.d/%{appname} condrestart > /dev/null 2>&1 || :

#============================================================================
%package		libs
Summary		:	Libraries used by the BIND DNS packages

#-----------------------------------------------------------------------------
%description		libs
Contains heavyweight version of BIND suite libraries
 used by both named DNS server and utilities in
bind-utils package.

#-----------------------------------------------------------------------------
%files			libs
%defattr(-,root,root,-)
%{_libdir}/bind/filter-a.so
%{_libdir}/bind/filter-aaaa.so
%{_libdir}/lib%{name}9-%{version}*.so
%{_libdir}/libisccc-%{version}*.so
%{_libdir}/libns-%{version}*.so
%{_libdir}/libdns-%{version}*.so
%{_libdir}/libirs-%{version}*.so
%{_libdir}/libisc-%{version}*.so
%{_libdir}/libisccfg-%{version}*.so

#============================================================================
%package		chroot
Summary		:	A chroot runtime environment for the DNS server, named(8)
Prefix		:	%{jail}

#-----------------------------------------------------------------------------
Requires	:	grep
Requires	:	%{name} = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		chroot
This package contains a tree of files which can be
used as a chroot(2) jail for the named(8) program
from the BIND package.
Based on the code from Jan "Yenya" Kasprzak <kas@fi.muni.cz>

#-----------------------------------------------------------------------------
%files			chroot
%defattr(-,root,root,-)
#jail area
%defattr(-,root,root,-)
%attr (0640,root,named) %config (noreplace) %{jail}%{_sysconfdir}/%{appname}.conf
%attr (0640,root,named) %config (noreplace) %{jail}%{_sysconfdir}/local.conf
%attr (0640,root,named) %config (noreplace) %{jail}%{_sysconfdir}/local_acl.conf
%attr (0640,root,named) %config (noreplace) %{jail}%{_sysconfdir}/local_options.conf
%attr (0640,root,named) %config (noreplace) %{jail}%{_sysconfdir}/namedb/conf/local.conf
%attr (0770,root,named) %dir %{jail}%{_sysconfdir}/namedb
%{_sysconfdir}/%{appname}
%{_var}/%{appname}
%{jail}%{_sysconfdir}/namedb/pz/127.0.0
%{jail}%{_sysconfdir}/namedb/named.root
%{jail}%{_sysconfdir}/namedb/root.hints
%{jail}%{_sysconfdir}/localtime
%attr (0660,root,root) %{jail}/dev/null
%attr (0660,root,root) %{jail}/dev/urandom
%dir %attr (1777,root,root) %{jail}/var/run
%dir %attr (0755,named,named) %{jail}/var/run/%{appname}

%post			chroot
if [ "$1" -gt 0 ]; then
  %{__cp} -aL %{_sysconfdir}/localtime %{jail}/%{_sysconfdir}/localtime
  fi
#to add/update an rndc.key file if necessary
if [ ! -f %{jail}%{_sysconfdir}/rndc.key ] ; then
  %{_sbindir}/rndc-confgen -b 512 -a -c %{jail}%{_sysconfdir}/rndc.key
  chown named:named 					\
	%{jail}%{_sysconfdir}/rndc.key
  fi

%preun			chroot
if [ "$1" = 0 ]; then
  if [ -f %{jail}%{_sysconfdir}/rndc.key ] ; then
    %{__rm} %{jail}%{_sysconfdir}/rndc.key
    %{__rm} %{jail}%{_sysconfdir}/localtime
    fi
  fi
#============================================================================
%package		devel
Summary		:	Utilities for querying DNS name servers

#-----------------------------------------------------------------------------
Requires	:	openssl-devel
Requires	:	%{name}-libs = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		devel
The %{name}-devel package contains full version of
the header files and libraries required for building
bind-dyndb-ldap. Upstream no longer supports nor
recommends bind libraries for third party applications

#-----------------------------------------------------------------------------
%files			devel
%defattr(-,root,root,-)
%{_includedir}/dns/*.h
%{_includedir}/dst/*.h
%{_includedir}/irs/*.h
%{_includedir}/isc/*.h
%{_includedir}/ns/*.h
%{_includedir}/isccfg/*.h
%{_includedir}/isccc/*.h
%{_includedir}/%{name}9/*.h
%{_libdir}/lib%{name}9.so
%{_libdir}/libisccc.so
%{_libdir}/libns.so
%{_libdir}/libdns.so
%{_libdir}/libirs.so
%{_libdir}/libisc.so
%{_libdir}/libisccfg.so

#============================================================================
%package		utils
Summary		:	Utilities for querying DNS name servers

#-----------------------------------------------------------------------------
Requires	:	%{name}-libs = %{version}-%{release}

#-----------------------------------------------------------------------------
%description		 utils
Bind-utils contains a collection of utilities for querying DNS (Domain
Name System) name servers to find out information about Internet
hosts. These tools will provide you with the IP addresses for given
host names, as well as other information about registered domains and
network addresses.

You should install bind-utils if you need to get information from DNS name
servers.
#-----------------------------------------------------------------------------
%files			utils
%defattr(-,root,root,-)
%{_bindir}/dig
%{_bindir}/host
%{_bindir}/nslookup
%{_bindir}/nsupdate
%{_mandir}/man1/host.1*
%{_mandir}/man1/nsupdate.1*
%{_mandir}/man1/dig.1*
%{_mandir}/man1/nslookup.1*

#============================================================================
%prep
%setup -q
tar xf %{SOURCE1}
#-----------------------------------------------------------------------------
#building application
%build

./configure							\
        --prefix=%{_prefix}					\
	--exec-prefix=%{_exec_prefix}				\
        --includedir=%{_includedir}				\
        --sysconfdir=%{_sysconfdir}				\
        --sbindir=%{_sbindir}					\
        --bindir=%{_bindir}					\
	--mandir=%{_mandir}					\
	--datadir=%{_datadir}					\
	--libdir=%{_libdir}					\
	--infodir=%{_infodir}					\
	--sharedstatedir=%{_var}/lib				\
	--localstatedir=%{_var}					\
	--docdir=%{_defaultdocdir}/%{name}-%{version}		\
	--enable-threads					\
	--with-libtool						\
	--disable-static					\
	--enable-chroot						\
	--with-openssl=yes					\
	--with-libjson=no					\
	--enable-ipv6						\
	--disable-doh						\

%define _smp_mflags -j%(/usr/bin/getconf _NPROCESSORS_ONLN)
%{__make} %{_smp_mflags}

#-----------------------------------------------------------------------------
%clean
%{__rm} -rf %{buildroot}

#installing program
#-----------------------------------------------------------------------------
%install
%define	buildjail	%{buildroot}%{jail}

%{__rm} -rf %{buildroot}

%{__make} DESTDIR=%{buildroot} install

# Remove unwanted files
%{__rm} -f %{buildroot}/etc/bind.keys

#installing bind starting/stopping script
%{__mkdir_p}	%{buildroot}%{_sysconfdir}/rc.d/init.d
%{__cp} -a 						\
	%{name}-ok_addon/%{appname}			\
	%{buildroot}%{_sysconfdir}/rc.d/init.d

#preparing logrotate script
%{__mkdir_p}	%{buildroot}%{_sysconfdir}/logrotate.d
%{__cp} -a 						\
	%{name}-ok_addon/%{appname}.logrotate		\
	%{buildroot}%{_sysconfdir}/logrotate.d/%{appname}


#jail area
(
%{__mkdir_p} %{buildjail}
cd %{buildjail}
%{__mkdir_p}						\
	dev						\
	etc/namedb/slave				\
	usr/lib/engines					\
	var/run/%{appname}

sudo mknod dev/null c 1 3
sudo mknod dev/urandom c 1 9

touch etc/localtime

)

#linking /etc/named to /jail/bin/etc
%{__ln_s}						\
	../..%{jail}/etc				\
	%{buildroot}%{_sysconfdir}/%{appname}

#preparing logrotate directory
%{__mkdir_p}	%{buildroot}%{_var}
%{__ln_s} 						\
	../..%{jail}/%{_sysconfdir}/namedb		\
	%{buildroot}%{_var}/%{appname}

#installing distribution configuration file
%{__cp} -a 						\
	%{name}-ok_addon/*.conf				\
	%{buildjail}%{_sysconfdir}

%{__cp} -a 						\
	%{name}-ok_addon/pz				\
	%{name}-ok_addon/named.root			\
	%{buildjail}%{_sysconfdir}/namedb

#preparing minimal configuration
%{__ln_s}						\
	./named.root					\
	%{buildjail}%{_sysconfdir}/namedb/root.hints
%{__mkdir_p}						\
	%{buildjail}%{_sysconfdir}/namedb/conf
touch							\
	%{buildjail}%{_sysconfdir}/namedb/conf/local.conf

	
#To remove libtool library
find 							\
	%{buildroot}%{_libdir}				\
	-name \*.la					\
	-delete

#-----------------------------------------------------------------------------
%changelog
